Package owl.automaton

## Class ImplicitCachedStatesAutomaton<S,A extends OmegaAcceptance>

- java.lang.Object
- - owl.automaton.AbstractAutomaton<S,A>
  - - owl.automaton.ImplicitCachedStatesAutomaton<S,A>

- All Implemented Interfaces:
    `Automaton<S,A>`
  Direct Known Subclasses:
    `Views.AutomatonView`

      public abstract class ImplicitCachedStatesAutomaton<S,A extends OmegaAcceptance>
      extends AbstractAutomaton<S,A>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface owl.automaton.Automaton

      `Automaton.EdgeVisitor<S>, Automaton.HybridVisitor<S>, Automaton.LabelledEdgeVisitor<S>, Automaton.Property, Automaton.Visitor<S>`

  - ### Field Summary

    - ### Fields inherited from class owl.automaton.AbstractAutomaton

      `acceptance, factory, initialStates`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ImplicitCachedStatesAutomaton​(ValuationSetFactory factory, Set<S> initialStates, A acceptance)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `accept​(Automaton.EdgeVisitor<S> visitor)` |
    `void` | `accept​(Automaton.LabelledEdgeVisitor<S> visitor)` |
    `protected Set<S>` | `cache()` |
    `Set<S>` | `states()` | The set of all from the initial states reachable states in this automaton.

    - ### Methods inherited from class owl.automaton.AbstractAutomaton

      `acceptance, factory, initialStates`

    - ### Methods inherited from interface owl.automaton.Automaton

      `accept, edge, edges, edges, forEachEdge, forEachLabelledEdge, is, labelledEdges, name, onlyInitialState, predecessors, prefersLabelled, size, successor, successors, successors`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ImplicitCachedStatesAutomaton

          public ImplicitCachedStatesAutomaton​(ValuationSetFactory factory,
                                               Set<S> initialStates,
                                               A acceptance)

  - ### Method Detail

    - #### states

          public final Set<S> states()

      Description copied from interface: `Automaton`
      The set of all from the initial states reachable states in this automaton.
      Returns:
        All reachable states

    - #### accept

          public final void accept​(Automaton.EdgeVisitor<S> visitor)

    - #### accept

          public final void accept​(Automaton.LabelledEdgeVisitor<S> visitor)

    - #### cache

          @Nullable
          protected final Set<S> cache()